PROGRAM Z8term;  {TERMINAL EMULATOR AND DOWN LOADER FOR KISS TNC2}

{ Written in Turbo Pascal ver. 3.0

     by Dale A. Heatherington   (last mod.  4/8/87 ) }

{$I COMLIB.PAS}     { a modified version of turbo pascal's comlib }

{$C-}                {CONTROL C & S CHECKING OFF }


TYPE LSTRING = STRING[255];
     SHSTR = STRING[2];
     regpac = RECORD
              AX,BX,CX,DX,BP,SI,DI,DS,ES,FLAGS : INTEGER;
              END;


CONST P = $3FD ;  { COM1 }
     BUFEND = 19999;  {20000 BYTE COM1 INPUT BUFFER}
     DDSEG = $04F0 ;  { ABSOLUTE ADDRESS WHERE DATA SEGMENT
                        ADDRESS IS STORED FOR USE BY PROCEDURE "COM1INTR" }

VAR     REGS : REGPAC;
        F: TEXT;
        CH,CHCOM,INTCH:CHAR;
        TS,BS,LASTSTR,LASTSTRB : LSTRING;
        TS2 : SHSTR;
        LEN,B : BYTE;
    ERRORS,ADDRESS:INTEGER;
    J,I,RESULT,SPEED:INTEGER;
    HEADER,DATA,SS : LSTRING;
   BUFFER:PACKED ARRAY[0..2047] OF CHAR;
   COM1BUF:PACKED ARRAY[0..BUFEND] OF CHAR;
   P1,INPTR,OUTPTR,SAVEDDSEG,SAVEDSEG,SAVEDOFS : INTEGER;
   STRRDY,PRINT : BOOLEAN;

{-----------------------------------------------------------------}
PROCEDURE COM1INTR;          {COM1 INTERRUPT SERVICE ROUTINE }
BEGIN
INLINE($50/$53/$51/$52/$56/$57/$1E/$06);     {   PUSH AX
                                                 PUSH BX
                                                 PUSH CX
                                                 PUSH DX
                                                 PUSH SI
                                                 PUSH DI
                                                 PUSH DS
                                                 PUSH ES   }

INLINE($B8/00/00/$50/$1F/$A1/DDSEG/$50/$1F/$FB);{MOV AX,0000
                                                 PUSH AX
                                                 POP  DS
                                                 MOV AX,[DDSEG]
                                                 PUSH AX
                                                 POP  DS
                                                 STI    }

INTCH := CHR(PORT[P-5]);
IF (INTCH <> CHR($C0)) AND (INTCH <> CHR(0)) THEN
 BEGIN
   COM1BUF[INPTR] := CHR(ORD(INTCH) AND $7F) ;{WRITE COM1 BYTE INTO BUFFER}
        INPTR := INPTR +1;
        IF INPTR > BUFEND THEN INPTR := 0;
      END;

PORT[$20] := $20;

INLINE($07/$1F/$5F/$5E/$5A/$59/$5B/$58/$8B/$E5/$5D/$CF);{POP  ES
                                                         POP  DS
                                                         POP  DI
                                                         POP  SI
                                                         POP  DX
                                                         POP  CX
                                                         POP  BX
                                                         POP  AX
                                                         MOV  SP,BP
                                                         POP  BP
                                                         IRET    }
END;
{---------------------------------------------}

PROCEDURE READCOM1(VAR S:LSTRING);
LABEL EXIT2;
VAR S1 : LSTRING;
    CH : CHAR;
    L,B  : BYTE;
    P  : INTEGER;

BEGIN
  L := 1;
  S := '';
REPEAT

   REPEAT
     IF  MEMW[0000:$041A] <> MEMW[0000:$041C]  THEN GOTO EXIT2;
   UNTIL  INPTR <> OUTPTR  ;
   CH := COM1BUF[OUTPTR];
   OUTPTR := OUTPTR+1;
   S[L] := CH;
   L := L+1;
UNTIL (CH = CHR($0D)) OR ( L > 80 );
   S[0] := CHR(L-2);
EXIT2:
END;




{-------------------------------------------------------}


PROCEDURE HEXASCII(N,H:INTEGER; VAR S:LSTRING);
VAR A1:ARRAY[0..15] OF CHAR;
    I,X:INTEGER;
BEGIN
  S := '';
  A1:='0123456789ABCDEF';
  X := 0;
  FOR I := 1 TO N DO
        BEGIN
          S := CONCAT(A1[(H SHR X) AND 15],S);
          X:=X+4;
        END;
END; {HEXASCII}
{---------------------------------------------------------------}
FUNCTION CONVNIBBLE(C : CHAR):BYTE;
VAR
     B : BYTE;

BEGIN
   B := 0   ;
  IF (C >='0') AND ( C <= '9' ) THEN B:= ORD(C) - ORD('0');
  IF (C >='A') AND ( C <= 'F' ) THEN B:= ORD(C) - ORD('A') + 10 ;
 CONVNIBBLE := B;
END;
{----------------------------------------}
FUNCTION CONVBYTE(S:SHSTR):BYTE;
VAR  B : BYTE;
    CH : CHAR;
BEGIN
  CH:= S[2];
  B := CONVNIBBLE(CH);
  CH := S[1];
  B := B + (16 * CONVNIBBLE(CH));
 CONVBYTE := B;
END;
{-----------------------------------------}




PROCEDURE GETFNAME(VAR S:LSTRING);   {GETS FILE NAME FROM MS DOS COMMAND LINE}
TYPE COMSTR = STRING [127];
VAR CPMCMDBUF: COMSTR ABSOLUTE CSEG:$80  ;

BEGIN
  S := CPMCMDBUF;
  DELETE(S,1,1);  {DELETE LEADING SPACE}
  S:= S+'.HEX' ;
END;
{----------------------------------------------------------------}
 PROCEDURE KISSTX(m,x,y,dtime:integer);
 LABEL EXIT99, EXIT00;
 VAR  P1,I,J,N :INTEGER;
      CRLF,SS,SS2 : STRING[255];
 BEGIN

  CLRSCR;
  WRITELN('TNC-2 KISS tx tester');
  WRITELN('any key to exit ' );
 { writeln('Enter value of delay between packets (ms) : ');
  readln(dtime);}
  dtime := 0;
  P1 := 0;


{this is for 2.5 millisecond resolution on KISS.MAC ie: 16*2.5 = 40 ms}
  WRITE(USR,CHR($C0),CHR(1),CHR(16), CHR($C0));      {TXDELAY}
  WRITE(USR,CHR($C0),CHR(2),CHR(255),CHR($C0));      {P}
  WRITE(USR,CHR($C0),CHR(3),CHR(4),  CHR($C0));      {SLOT TIME}
  WRITE(USR,CHR($C0),CHR(4),CHR(1),  CHR($C0));      {TX TAIL}

CRLF := CHR($0D) + CHR($0A);

case m of
1: SS:=' The quick brown fox jumped over the lazy dogs back.  DE WA4DSY' + CRLF;
2: SS:=' The quick 56 KBaud Modem jumped over the the TAPR TNC-2.  DE WA4DSY'+CRLF;
end; {case}

SS2 := CHR($1A) + CRLF;

IF Y=1 THEN
         BEGIN
           WRITE(USR,CHR($C0),CHR(00),CHR($1A),CHR($C0) );  {CLEAR REMOTES SCREEN}
           SS2 := CRLF;
          END;

N:=1;
       FOR I := 1 TO X DO
        BEGIN
         REPEAT UNTIL (PORT[$3FE] AND $10) <> 0 ;{ WAIT FOR CTS}
         WRITE(USR,CHR($C0),CHR(00),SS2);
         for j := 1 to Y do
              BEGIN
              IF INPTR <> OUTPTR THEN GOTO EXIT00; {abort if tnc says something}
              WRITE(USR,N:3,SS);
              N:=N+1;
              END;
          WRITE(USR,CHR($C0));
          IF  MEMW[0000:$041A] <> MEMW[0000:$041C]  THEN GOTO EXIT99;
          delay(dtime);

        END;

{     WRITE(USR,CHR($C0));          }

EXIT99:
WRITELN('TX TEST COMPLETE, RETURNING TO TERMINAL MODE');
EXIT00:
END;
{----------------------------------------------------------------}
PROCEDURE SENDFILE;
LABEL EXITSF;
VAR S:STRING[20];
    BUFR : STRING[255];
    I,J : INTEGER;
BEGIN
  WRITE('ENTER TEXT FILE NAME : ');
  READLN(S);
  ASSIGN(F,S);
  {I-}
  RESET(F);
  IF IORESULT > 0 THEN
         BEGIN
           WRITELN(S, ' FILE NOT FOUND');
           GOTO EXITSF;
         END;
  REPEAT
      WRITE(USR,CHR($C0),CHR(0) );     {START A PACKET}
      FOR I := 1 TO 10 DO             {10 LINES / PACKET}
      BEGIN
        READLN(F,BUFR);
        WRITELN(USR,BUFR);
        IF EOF(F) THEN
                      BEGIN
                        WRITE(USR,CHR($C0));
                        CLOSE(F);
                        GOTO EXITSF;
                      END;
      IF  MEMW[0000:$041A] <> MEMW[0000:$041C]  THEN GOTO EXITSF;
      END;
      WRITE(USR,CHR($C0));           {END A PACKET}

   UNTIL 1<>1;
EXITSF:
 {I+}
END;
{-----------------------------------------------------------}


PROCEDURE DOWNLOAD(COMSTR :LSTRING);
LABEL EXIT1;
VAR  BYTES,I,X : INTEGER;
         S : STRING[4];
BEGIN
  WRITELN;
  DELETE(COMSTR,1,3);
  IF POS('.HEX',COMSTR) = 0 THEN  COMSTR := COMSTR + '.HEX';

  ASSIGN(F,COMSTR);
  {$I-}  RESET(F);
  IF IORESULT > 0 THEN
        BEGIN
          WRITELN(COMSTR,' FILE NOT FOUND',CHR($07));
          WRITE(USR,CHR($1B));      {SEND ESCAPE TO TNC MONITOR}
         GOTO EXIT1;
        END;
  {$I+}
  WRITELN('DOWN LOADING ',COMSTR);
  BYTES := 0;
  I := 1;
  WHILE (NOT EOF(F)) AND (I >0) DO
  BEGIN
    IF (INPTR <> OUTPTR)  THEN
                                       {TNC MONITOR LOAD ABORT}
                BEGIN
                CLOSE(F);
                WRITELN('  TNC LOAD ABORT');
                GOTO EXIT1;
                END;
    READLN(F,BS);
    WRITELN(USR,BS);
    S := '$' + COPY(BS,2,2);
    VAL(S,I,X);
    BYTES := BYTES + I;
    WRITE(CHR($0D),BYTES:4);

  END;
  WRITELN('  BYTES LOADED,  STARTING ADDRESS= ',COPY(BS,4,4),CHR(7) );
  CLOSE(F);
EXIT1:  ;

END;
{---------------------------------------------------------------}

BEGIN

  SPEED := 9600;
  ASSIGNUSR(1);
  SETSERIAL(1,SPEED,1,8,NONE);

  REGS.AX := $350C;
  MSDOS(REGS);                       {GET AND SAVE OLD IRQ4 VECTOR }
  SAVEDSEG := REGS.ES;
  SAVEDOFS := REGS.BX;
  SAVEDDSEG := MEMW[0:DDSEG] ;        {SAVE OLD CONTENTS OF "DDSEG" }

  REGS.AX := $250C;            {SET UP IRQ4 (COM1) INTERRUPT VECTOR }
  REGS.DS := CSEG ;
  REGS.DX := OFS(COM1INTR);
  MSDOS(REGS);

  MEMW[0:DDSEG] := DSEG;   {STORE DATA SEGMENT ADDRESS FOR USE BY "COM1INTR"}

  INLINE($FA);  {CLI}

  INPTR := 0;
  OUTPTR := 0;
  PORT[P-2] := PORT[P-2] AND $7F ;
  B := PORT[P-5];
  PORT[P-4] := $01;                {ENABLE DATA AVAL. INTERRUPT}
  PORT[P-1] := $0B;                {MODEM CONTROL REG.  ENAB. DTR,RTS,OUT2 }
  PORT[$21] := PORT[$21] AND $EF ; {ENABLE IRQ4 ON 8259 INT. CONTROLLER CHIP }
  INLINE($FB);  {STI}

  STRRDY := FALSE;
  PRINT  := FALSE;
  CLRSCR;
  WRITELN('TNC-2 TERMINAL PROGRAM VER 2.0     (COM1, ',SPEED:7,' BAUD) ');
  WRITELN(' ^C TO EXIT TO DOS');
  P1 := 0;
  WRITE(USR,CHR($20));

  REPEAT
    CH := CHR(0);
    IF INPTR <> OUTPTR THEN
         BEGIN
            CHCOM := COM1BUF[OUTPTR] ;
            WRITE(CHCOM);
            IF PRINT THEN WRITE(LST,CHCOM);

            IF ORD(CHCOM) = $0D THEN
                  BEGIN
                     LASTSTRB[0] := CHR(P1)   ;
                     P1 := 0;
                     LASTSTR := LASTSTRB ;
                     STRRDY := TRUE;
                  END;

              IF ORD(CHCOM) > $1F THEN
              BEGIN
                 P1 := P1+1;
                 LASTSTRB[P1] := CHCOM;
              END
              ELSE
               BEGIN
                 CASE ORD(CHCOM) OF
                 $1A : CLRSCR;
                 END; {CASE}
               END;

            OUTPTR := OUTPTR+1;
            IF OUTPTR > BUFEND THEN OUTPTR := 0;
         END;
    IF MEMW[0:$41A] <> MEMW[0:$41C] THEN
         BEGIN
           READ(KBD,CH);
           IF ORD(CH) = $10 THEN PRINT := NOT PRINT ;  { CONTROL P}

           CASE ORD(CH) OF
           $0B : KISSTX(1,1,23,0);
           $0E : KISSTX(1,50,1,0);
           $01 : KISSTX(2,1,23,0);
           $12 : SENDFILE;
           ELSE
           PORT[$3FD-5] := ORD(CH);
           END; {CASE}

         END;

IF STRRDY THEN
  BEGIN
   TS := COPY(LASTSTR,1,3);
   IF (TS = '*L ') OR (TS = '*l ') THEN DOWNLOAD(LASTSTR);
;
  STRRDY := FALSE;
  END;

   UNTIL CH = CHR($03);

 PORT[P-1] := 0;
 PORT[P-4] := 0;     {DISABLE INTERRUPTS}
 port[$21] := PORT[$21] OR $10;
   REGS.AX := $250C;            {PUT OLD IRQ4 VECTOR BACK}
   REGS.DS := SAVEDSEG;
   REGS.DX := SAVEDOFS;
   MSDOS(REGS);
   MEMW[0:DDSEG] := SAVEDDSEG ;        {RESTORE OLD CONTENTS OF "DDSEG" }

 END.







